<?php
 
namespace IPS\dp42sulk;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Card Model
 */
class _Key extends \IPS\Patterns\ActiveRecord
{	
	/**
	 * @brief	Database Table
	 */
	public static $databaseTable = 'dp42sulk_keys';
	
	/**
	 * @brief	Application
	 */
	public static $application = 'dp42sulk';
    
	/**
	 * @brief	Module
	 */
	public static $module = 'manage';    
	
	/**
	 * @brief	Database Prefix
	 */
	public static $databasePrefix = 'l_';
	
	/**
	 * @brief	[ActiveRecord] ID Database Column
	 */
	public static $databaseColumnId = 'id';
    
	/**
	 * @brief	Form Lang Prefix
	 */
	public static $formLangPrefix = 'dp42sulk_keys__';     
    		
	/**
	 * @brief	Database Column Map
	 */
	public static $databaseColumnMap = array(
			'used_date'			 => 'time',          
	);
	
	/**
	 * @brief	Title
	 */
	public static $title = 'dp42sulk_key';
	
    /**
	 * @brief	[Node] Node Title
	 */
	public static $nodeTitle = 'dp42sulk';
        
    /**
	 * @brief	[Node] Order Database Column
	 */
	public static $databaseColumnOrder = 'l_key';
	
    /**
	 * @brief	[Node] Sortable?
	 */
	public static $nodeSortable = FALSE;
    
    /**
	 * @brief	[Node] Parent ID Database Column
	 */
	public static $databaseColumnParent = null;
    
	/**
	 * @brief	Title
	 */
	public static $icon = 'key';

	/**
	 * @brief	Database ID Fields
	 */
	protected static $databaseIdFields = array();
    
    /**
	 * [Node] Does the currently logged in user have permission to copy this node?
	 *
	 * @return	bool
	 */
	public function canCopy()
	{
        return false;
	}
	
    /**
	 * Set Default Values (overriding $defaultValues)
	 *
	 * @return	void
	 */
	protected function setDefaultValues()
	{
        $this->used_date = 0;	
	} 
    
    /**
	 * @brief	Cached URL
	 */
	protected $_url	= NULL;
    
	public function acpUrl()
	{
		return \IPS\Http\Url::internal( "app=dp42sulk&module=manage&controller=index", 'admin' );
	}
}