<?php

namespace IPS\dp42sulk;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Form helper class for linked screenshots
 */
class _Settings
{
    
	public function eloInit()
    {
    }
    
    public static function updateStock( $id = 0 )
    {
		$where = array( 'p_lkey = ?', 'sulk' );
        
        if( $id )
        {
            $where = array( 'p_lkey = ? AND p_id = ?', 'sulk', $id );
        }
        
        foreach( \IPS\Db::i()->select( '*', 'nexus_packages_products', $where ) as $product )
		{
            $howMany = \IPS\Db::i()->select( 'COUNT(*)', 'dp42sulk_keys', array( 'l_product_id = ? AND l_used_date = ?', $product['p_id'], 0 ) )->first();
            \IPS\Db::i()->update( 'nexus_packages', array( 'p_stock' => $howMany ), array( 'p_id = ?', $product['p_id'] ) );
		}
    }
    
    public static function getRandom( $purchase )
    {
        /* Generate random key */
        try
		{
			$key = \IPS\Db::i()->select( '*', 'dp42sulk_keys', array( 'l_used_date = ? AND l_product_id = ?', 0, $purchase->item_id ), "RAND()" )->first();
            
            \IPS\Db::i()->update( 'dp42sulk_keys', array( 'l_used_date' => time(), 'l_purchase_id' => $purchase->id ), array( 'l_id = ?', $key['l_id'] ) );
            return $key['l_key'];
		}
		catch( \UnderflowException $e )
        {
        }
    }

    public static function getAndSetRandom( $productId = 0, $purchaseId = 0, $invoiceId = 0 )
    {
		try
		{
			$key = \IPS\Db::i()->select( '*', 'dp42sulk_keys', array( 'l_used_date = ? AND l_product_id = ?', 0, $productId ), "RAND()" )->first();
            
            \IPS\Db::i()->update( 'dp42sulk_keys', array( 'l_used_date' => time(), 'l_purchase_id' => $purchaseId, 'l_invoice_id' => $invoiceId ), array( 'l_id = ?', $key['l_id'] ) );
            return $key['l_key'];
		}
		catch( \UnderflowException $e ) {}
    }
        
    public static function getOldKeys( $purchase )
    {
    	/* Init */
        $rows     = array();
        $whereAdd = '';
        
        if( $lkey = $purchase->licenseKey() )
        {
            $whereAdd = " OR l_key = '" . \IPS\Db::i()->escape_string( $lkey->key ) . "'";
        }
        
        /* Build where */
        $where   = array();
        $where[] = array( 'l_purchase_id = ' . $purchase->id . $whereAdd );
	
        /* Get only renew keys */		
    	foreach( new \IPS\Patterns\ActiveRecordIterator( \IPS\Db::i()->select( '*', 'dp42sulk_keys', $where, 'l_used_date DESC' ), 'IPS\dp42sulk\Key' ) as $key )
    	{
    		$rows[ $key->id ] = $key;
    	}
        
        /* Return */ 
    	return $rows;
    }
}